/**
 *  @file    instr.h
 *  @author  Guillaume Bour. 2002
 
 *  @version 0.1
 *    @date  01/02/2002

 *  instructions declaration
 */
#ifndef _INSTR_H_
#define _INSTR_H_

#include <gtk/gtk.h>
#include "type.h"
#include "op.h"
#include "middle-code.h"

/*>> instructions structure                                                  */
struct s_instr {
  type_t type;          /*>>> instruction type                               */
  op_t op;              /*>>> instruction operator                           */

  struct s_mc *arg1;    /*>>> 1st argument                                   */
  struct s_mc *arg2;    /*>>> 2d argument                                    */

  gpointer value;       /*>>> instruction current value (used for execution) */
};

/*>>> functions prototypes                                                   */
struct s_instr *instr_alloc(op_t, type_t, struct s_mc *, struct s_mc *);
void instr_free(gpointer, gpointer);
#ifdef DEBUG1
void instr_debug(gpointer, gpointer);
#endif
#endif /* _INSTR_H_ */
