/**
 *  @file    proc.h
 *  @author  Guillaume Bour. 2002
 
 *  @version 0.1
 *    @date  01/02/2002

 *  procedures definition
 */
#ifndef __MIDDLE_CODE_H__
#define __MIDDLE_CODE_H__

#include <gtk/gtk.h>

/*>>> procedure definition                                                   */
struct s_proc {
  gchar *name;          /*>> procedure name                                  */
  GSList *instructions, /*>> list of procedure's instructions                */
         *parameters,   /*>> list of procedure's parameters                  */
         *variables;    /*>> list of procedure's inner variables             */
  
  gpointer retval;      /*>> procedure return value (use for execution)      */
};

/*>>> functions prototypes                                                   */
struct s_proc *proc_alloc(gchar *);
void proc_free(gpointer, gpointer);
gint proc_comparison(gconstpointer, gconstpointer);
#ifdef DEBUG1
void proc_debug(gpointer, gpointer);
#endif
#endif /* __MIDDLE_CODE_H__ */
